#!/bin/sh
#-
# Copyright (c) 2012 Devin Teske
# All Rights Reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
# DAMAGES (INLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
# SUCH DAMAGE.
#
# $FreeBSD$
#
############################################################ INCLUDES

BSDCFG_LIBE="/usr/libexec/bsdconfig"
. $BSDCFG_LIBE/include/common.subr || exit 1
f_include $BSDCFG_LIBE/include/dialog.subr
f_include $BSDCFG_LIBE/include/mustberoot.subr
f_include $BSDCFG_LIBE/include/sysrc.subr

APP_DIR="130.security"
f_include_lang $BSDCFG_LIBE/$APP_DIR/include/messages.subr

ipgm=$( f_index_menu_selection $BSDCFG_LIBE/$APP_DIR/INDEX "$pgm" )
[ $? -eq $SUCCESS -a "$ipgm" ] && pgm="$ipgm"

############################################################ FUNCTIONS

# dialog_menu_main
#
# Display the dialog(1)-based application main menu.
#
dialog_menu_main()
{
	local menu_list size
	local hline="$hline_arrows_tab_enter"
	local prompt="$msg_menu_text"

	menu_list="
		'X <<< $msg_exit' '$msg_exit_this_menu'
	" # END-QUOTE

	case "$( f_sysrc_get kern_securelevel_enable )" in
	[Yy][Ee][Ss])
		local kern_securelevel="$( f_sysrc_get kern_securelevel )"
		if [ ${#kern_securelevel} -eq 1 ] &&
		   f_isinteger "$kern_securelevel"
		then menu_list="$menu_list
			'2 [$kern_securelevel] $msg_securelevel'"
		else menu_list="$menu_list
			'2 [X] $msg_securelevel'"
		fi
		menu_list="$menu_list '$msg_securelevel_desc'"
		;;
	*) menu_list="$menu_list
		'2 [ ] $msg_securelevel' '$msg_securelevel_desc'"
	esac

	case "$( f_sysrc_get nfs_reserved_port_only )" in
	[Yy][Ee][Ss]) menu_list="$menu_list
		'3 [X] $msg_nfs_port' '$msg_nfs_port_desc'";;
	*) menu_list="$menu_list
		'3 [ ] $msg_nfs_port' '$msg_nfs_port_desc'";;
	esac

	size=$( eval f_dialog_menu_size \
	        	\"\$DIALOG_TITLE\"     \
	        	\"\$DIALOG_BACKTITLE\" \
	                \"\$prompt\"           \
	        	\"\$hline\"            \
	        	$menu_list             )

	eval $DIALOG \
		--clear --title \"\$DIALOG_TITLE\" \
		--backtitle \"\$DIALOG_BACKTITLE\" \
		--hline \"\$hline\"                \
		--ok-label \"\$msg_ok\"            \
		--cancel-label \"\$msg_cancel\"    \
		--menu \"\$prompt\" $size          \
		$menu_list                         \
		2> "$DIALOG_TMPDIR/dialog.menu.$$"
}

############################################################ MAIN

# Incorporate rc-file if it exists
[ -f "$HOME/.bsdconfigrc" ] && f_include "$HOME/.bsdconfigrc"

#
# Process command-line arguments
#
while getopts SX flag; do
	case "$flag" in
	\?) f_usage $BSDCFG_LIBE/$APP_DIR/USAGE "PROGRAM_NAME" "$pgm";;
	esac
done
shift $(( $OPTIND - 1 ))

#
# Initialize
#
f_dialog_init
f_dialog_title "$msg_system_security_options_menu"
f_dialog_backtitle "${ipgm:+bsdconfig }$pgm"
f_mustberoot_init

#
# Launch application main menu
#
while :; do
	dialog_menu_main
	retval=$?
	mtag=$( f_dialog_menutag )

	[ $retval -eq 0 ] || f_die

	case "$mtag" in
	"X <<< $msg_exit") break ;;
	"2 ["?"] $msg_securelevel") # Configure securelevels for the system
		$BSDCFG_LIBE/$APP_DIR/kern_securelevel ${USE_XDIALOG:+-X} ;;
	"3 [X] $msg_nfs_port") # Require that NFS clients use reserved ports
		f_sysrc_set nfs_reserved_port_only "NO";;
	"3 [ ] $msg_nfs_port") # Same; Toggle value
		f_sysrc_set nfs_reserved_port_only "YES";;
	esac

done

exit $SUCCESS

################################################################################
# END
################################################################################
